;------------------------------------------------------------------------
; Solar Assembler example of making ELF32 object file
;
; build with:
;	 sol_asm2 test.asm test.obj -elf32
;
; link with:
;	gcc test.obj -o test.exe
;
; run:
;	./test.exe 
;-----------------------------------------------------------------------

section ".text"		class_code
section ".data"		class_data

;-----------------------
; functions from libC
;-----------------------
extern 	puts	cdecl
extern 	exit	cdecl
extern	printf	cdecl

.entry main

..data
	msg_01		db	13,10,'Hi from Sol_Asm LIBC sample',0
	msg_02		db	13,10,'Message number 02',0
	msg_fmt		db	13,10,'Printf message: number1=%x main=%x ',13,10,0
..text

main:
	;-------------------------------
	; use libc puts to write strings
	;-------------------------------
	invoke	puts,msg_01

	invoke	puts,msg_02

	;-----------------------
	; use libc printf
	;-----------------------
	invoke	printf, msg_fmt,777h,main

	;------------------------
	; libC exit function
	;------------------------
	invoke	exit,77h

	ret

;-----------------------------
; the end of this programm
;-----------------------------
